## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Tests for student payments.

"""

from waeup.sirp.testing import FunctionalLayer, FunctionalTestCase
from waeup.sirp.students.payments import (
    StudentOnlinePayment, StudentOnlinePaymentFactory)
from waeup.sirp.payments.interfaces import IOnlinePayment
from waeup.sirp.students.interfaces import IStudentNavigation

class StudentOnlinePaymentFactoryTest(FunctionalTestCase):

    layer = FunctionalLayer

    def setUp(self):
        super(StudentOnlinePaymentFactoryTest, self).setUp()
        self.factory = StudentOnlinePaymentFactory()
        return

    def tearDown(self):
        super(StudentOnlinePaymentFactoryTest, self).tearDown()
        return

    def test_factory(self):
        obj = self.factory()
        assert isinstance(obj, StudentOnlinePayment)

    def test_getInterfaces(self):
        implemented_by = self.factory.getInterfaces()
        assert implemented_by.isOrExtends(IOnlinePayment)
        assert implemented_by.isOrExtends(IStudentNavigation)