# Test the public API part of the university subpackage
import unittest
from waeup.sirp.university import *
from waeup.sirp.testing import get_doctest_suite

class UniversitySubpackageTests(unittest.TestCase):

    def test_public_api(self):
        names = globals().keys()
        self.assertTrue('Course' in names)
        self.assertTrue('CourseContainer' in names)
        self.assertTrue('Faculty' in names)
        self.assertTrue('FacultyContainer' in names)

def test_suite():
    # collect doctests for university subpackage
    suite = get_doctest_suite(['university/courserefs.txt',])
    # add local unittests (actually only one)
    for testcase in [UniversitySubpackageTests,]:
        suite.addTests(unittest.TestLoader().loadTestsFromTestCase(
                testcase))
    return suite
