##
## restwidget.py
## 
## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""A widget that renders restructured text. 
"""
from zope.formlib.textwidgets import TextWidget
from zope.formlib.widget import renderElement, DisplayWidget
from waeup.sirp.utils.helpers import ReST2HTML


class ReSTDisplayWidget(DisplayWidget):
    """Restructured Text widget.
    """

    def __call__(self):
        if self._renderedValueSet():
            value = self._data
        else:
            value = self.context.default
        if value == self.context.missing_value:
            return ""
        return renderElement(u'div id="rest"',
                             contents=ReST2HTML(value))